package com.rebusland.fin.derivatives.eq.server.input.model;

import java.util.List;

import org.joda.beans.ImmutableBean;
import org.joda.beans.gen.BeanDefinition;
import org.joda.beans.gen.PropertyDefinition;

import com.google.common.collect.ImmutableList;
import com.rebusland.fin.derivatives.eq.server.common.model.SerializableBeanFacade;
import com.rebusland.fin.derivatives.eq.server.enums.model.AverageType;
import com.rebusland.fin.derivatives.eq.server.enums.model.CallPut;

import java.util.Map;
import java.util.NoSuchElementException;
import org.joda.beans.Bean;
import org.joda.beans.JodaBeanUtils;
import org.joda.beans.MetaBean;
import org.joda.beans.MetaProperty;
import org.joda.beans.impl.direct.DirectFieldsBeanBuilder;
import org.joda.beans.impl.direct.DirectMetaBean;
import org.joda.beans.impl.direct.DirectMetaProperty;
import org.joda.beans.impl.direct.DirectMetaPropertyMap;

@BeanDefinition
public class AsianOption extends SerializableBeanFacade implements ImmutableBean {
	@PropertyDefinition(validate = "notNull")
	private final CallPut callPut;

	@PropertyDefinition(validate = "notNull")
	private final List<Long> strikeFixingDates;

	@PropertyDefinition(validate = "notNull")
	private final AverageType avgTypeStrike;

	@PropertyDefinition(validate = "notNull")
	private final List<Long> priceFixingDates;

	@PropertyDefinition(validate = "notNull")
	private final AverageType avgTypePrice;

	//------------------------- AUTOGENERATED START -------------------------
	/**
	 * The meta-bean for {@code AsianOption}.
	 * @return the meta-bean, not null
	 */
	public static AsianOption.Meta meta() {
		return AsianOption.Meta.INSTANCE;
	}

	static {
		MetaBean.register(AsianOption.Meta.INSTANCE);
	}

	/**
	 * Returns a builder used to create an instance of the bean.
	 * @return the builder, not null
	 */
	public static AsianOption.Builder builder() {
		return new AsianOption.Builder();
	}

	/**
	 * Restricted constructor.
	 * @param builder  the builder to copy from, not null
	 */
	protected AsianOption(AsianOption.Builder builder) {
		JodaBeanUtils.notNull(builder.callPut, "callPut");
		JodaBeanUtils.notNull(builder.strikeFixingDates, "strikeFixingDates");
		JodaBeanUtils.notNull(builder.avgTypeStrike, "avgTypeStrike");
		JodaBeanUtils.notNull(builder.priceFixingDates, "priceFixingDates");
		JodaBeanUtils.notNull(builder.avgTypePrice, "avgTypePrice");
		this.callPut = builder.callPut;
		this.strikeFixingDates = ImmutableList.copyOf(builder.strikeFixingDates);
		this.avgTypeStrike = builder.avgTypeStrike;
		this.priceFixingDates = ImmutableList.copyOf(builder.priceFixingDates);
		this.avgTypePrice = builder.avgTypePrice;
	}

	@Override
	public AsianOption.Meta metaBean() {
		return AsianOption.Meta.INSTANCE;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the callPut.
	 * @return the value of the property, not null
	 */
	public CallPut getCallPut() {
		return callPut;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the strikeFixingDates.
	 * @return the value of the property, not null
	 */
	public List<Long> getStrikeFixingDates() {
		return strikeFixingDates;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the avgTypeStrike.
	 * @return the value of the property, not null
	 */
	public AverageType getAvgTypeStrike() {
		return avgTypeStrike;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the priceFixingDates.
	 * @return the value of the property, not null
	 */
	public List<Long> getPriceFixingDates() {
		return priceFixingDates;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the avgTypePrice.
	 * @return the value of the property, not null
	 */
	public AverageType getAvgTypePrice() {
		return avgTypePrice;
	}

	//-----------------------------------------------------------------------
	/**
	 * Returns a builder that allows this bean to be mutated.
	 * @return the mutable builder, not null
	 */
	public Builder toBuilder() {
		return new Builder(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj != null && obj.getClass() == this.getClass()) {
			AsianOption other = (AsianOption) obj;
			return JodaBeanUtils.equal(callPut, other.callPut) &&
					JodaBeanUtils.equal(strikeFixingDates, other.strikeFixingDates) &&
					JodaBeanUtils.equal(avgTypeStrike, other.avgTypeStrike) &&
					JodaBeanUtils.equal(priceFixingDates, other.priceFixingDates) &&
					JodaBeanUtils.equal(avgTypePrice, other.avgTypePrice);
		}
		return false;
	}

	@Override
	public int hashCode() {
		int hash = getClass().hashCode();
		hash = hash * 31 + JodaBeanUtils.hashCode(callPut);
		hash = hash * 31 + JodaBeanUtils.hashCode(strikeFixingDates);
		hash = hash * 31 + JodaBeanUtils.hashCode(avgTypeStrike);
		hash = hash * 31 + JodaBeanUtils.hashCode(priceFixingDates);
		hash = hash * 31 + JodaBeanUtils.hashCode(avgTypePrice);
		return hash;
	}

	@Override
	public String toString() {
		StringBuilder buf = new StringBuilder(192);
		buf.append("AsianOption{");
		int len = buf.length();
		toString(buf);
		if (buf.length() > len) {
			buf.setLength(buf.length() - 2);
		}
		buf.append('}');
		return buf.toString();
	}

	protected void toString(StringBuilder buf) {
		buf.append("callPut").append('=').append(JodaBeanUtils.toString(callPut)).append(',').append(' ');
		buf.append("strikeFixingDates").append('=').append(JodaBeanUtils.toString(strikeFixingDates)).append(',').append(' ');
		buf.append("avgTypeStrike").append('=').append(JodaBeanUtils.toString(avgTypeStrike)).append(',').append(' ');
		buf.append("priceFixingDates").append('=').append(JodaBeanUtils.toString(priceFixingDates)).append(',').append(' ');
		buf.append("avgTypePrice").append('=').append(JodaBeanUtils.toString(avgTypePrice)).append(',').append(' ');
	}

	//-----------------------------------------------------------------------
	/**
	 * The meta-bean for {@code AsianOption}.
	 */
	public static class Meta extends DirectMetaBean {
		/**
		 * The singleton instance of the meta-bean.
		 */
		static final Meta INSTANCE = new Meta();

		/**
		 * The meta-property for the {@code callPut} property.
		 */
		private final MetaProperty<CallPut> callPut = DirectMetaProperty.ofImmutable(
				this, "callPut", AsianOption.class, CallPut.class);
		/**
		 * The meta-property for the {@code strikeFixingDates} property.
		 */
		@SuppressWarnings({"unchecked", "rawtypes" })
		private final MetaProperty<List<Long>> strikeFixingDates = DirectMetaProperty.ofImmutable(
				this, "strikeFixingDates", AsianOption.class, (Class) List.class);
		/**
		 * The meta-property for the {@code avgTypeStrike} property.
		 */
		private final MetaProperty<AverageType> avgTypeStrike = DirectMetaProperty.ofImmutable(
				this, "avgTypeStrike", AsianOption.class, AverageType.class);
		/**
		 * The meta-property for the {@code priceFixingDates} property.
		 */
		@SuppressWarnings({"unchecked", "rawtypes" })
		private final MetaProperty<List<Long>> priceFixingDates = DirectMetaProperty.ofImmutable(
				this, "priceFixingDates", AsianOption.class, (Class) List.class);
		/**
		 * The meta-property for the {@code avgTypePrice} property.
		 */
		private final MetaProperty<AverageType> avgTypePrice = DirectMetaProperty.ofImmutable(
				this, "avgTypePrice", AsianOption.class, AverageType.class);
		/**
		 * The meta-properties.
		 */
		private final Map<String, MetaProperty<?>> metaPropertyMap$ = new DirectMetaPropertyMap(
				this, null,
				"callPut",
				"strikeFixingDates",
				"avgTypeStrike",
				"priceFixingDates",
				"avgTypePrice");

		/**
		 * Restricted constructor.
		 */
		protected Meta() {
		}

		@Override
		protected MetaProperty<?> metaPropertyGet(String propertyName) {
			switch (propertyName.hashCode()) {
				case 548617169:  // callPut
					return callPut;
				case 1185064902:  // strikeFixingDates
					return strikeFixingDates;
				case -175079426:  // avgTypeStrike
					return avgTypeStrike;
				case 267665871:  // priceFixingDates
					return priceFixingDates;
				case 1792628605:  // avgTypePrice
					return avgTypePrice;
			}
			return super.metaPropertyGet(propertyName);
		}

		@Override
		public AsianOption.Builder builder() {
			return new AsianOption.Builder();
		}

		@Override
		public Class<? extends AsianOption> beanType() {
			return AsianOption.class;
		}

		@Override
		public Map<String, MetaProperty<?>> metaPropertyMap() {
			return metaPropertyMap$;
		}

		//-----------------------------------------------------------------------
		/**
		 * The meta-property for the {@code callPut} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<CallPut> callPut() {
			return callPut;
		}

		/**
		 * The meta-property for the {@code strikeFixingDates} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<List<Long>> strikeFixingDates() {
			return strikeFixingDates;
		}

		/**
		 * The meta-property for the {@code avgTypeStrike} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<AverageType> avgTypeStrike() {
			return avgTypeStrike;
		}

		/**
		 * The meta-property for the {@code priceFixingDates} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<List<Long>> priceFixingDates() {
			return priceFixingDates;
		}

		/**
		 * The meta-property for the {@code avgTypePrice} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<AverageType> avgTypePrice() {
			return avgTypePrice;
		}

		//-----------------------------------------------------------------------
		@Override
		protected Object propertyGet(Bean bean, String propertyName, boolean quiet) {
			switch (propertyName.hashCode()) {
				case 548617169:  // callPut
					return ((AsianOption) bean).getCallPut();
				case 1185064902:  // strikeFixingDates
					return ((AsianOption) bean).getStrikeFixingDates();
				case -175079426:  // avgTypeStrike
					return ((AsianOption) bean).getAvgTypeStrike();
				case 267665871:  // priceFixingDates
					return ((AsianOption) bean).getPriceFixingDates();
				case 1792628605:  // avgTypePrice
					return ((AsianOption) bean).getAvgTypePrice();
			}
			return super.propertyGet(bean, propertyName, quiet);
		}

		@Override
		protected void propertySet(Bean bean, String propertyName, Object newValue, boolean quiet) {
			metaProperty(propertyName);
			if (quiet) {
				return;
			}
			throw new UnsupportedOperationException("Property cannot be written: " + propertyName);
		}

	}

	//-----------------------------------------------------------------------
	/**
	 * The bean-builder for {@code AsianOption}.
	 */
	public static class Builder extends DirectFieldsBeanBuilder<AsianOption> {

		private CallPut callPut;
		private List<Long> strikeFixingDates = ImmutableList.of();
		private AverageType avgTypeStrike;
		private List<Long> priceFixingDates = ImmutableList.of();
		private AverageType avgTypePrice;

		/**
		 * Restricted constructor.
		 */
		protected Builder() {
		}

		/**
		 * Restricted copy constructor.
		 * @param beanToCopy  the bean to copy from, not null
		 */
		protected Builder(AsianOption beanToCopy) {
			this.callPut = beanToCopy.getCallPut();
			this.strikeFixingDates = ImmutableList.copyOf(beanToCopy.getStrikeFixingDates());
			this.avgTypeStrike = beanToCopy.getAvgTypeStrike();
			this.priceFixingDates = ImmutableList.copyOf(beanToCopy.getPriceFixingDates());
			this.avgTypePrice = beanToCopy.getAvgTypePrice();
		}

		//-----------------------------------------------------------------------
		@Override
		public Object get(String propertyName) {
			switch (propertyName.hashCode()) {
				case 548617169:  // callPut
					return callPut;
				case 1185064902:  // strikeFixingDates
					return strikeFixingDates;
				case -175079426:  // avgTypeStrike
					return avgTypeStrike;
				case 267665871:  // priceFixingDates
					return priceFixingDates;
				case 1792628605:  // avgTypePrice
					return avgTypePrice;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
		}

		@SuppressWarnings("unchecked")
		@Override
		public Builder set(String propertyName, Object newValue) {
			switch (propertyName.hashCode()) {
				case 548617169:  // callPut
					this.callPut = (CallPut) newValue;
					break;
				case 1185064902:  // strikeFixingDates
					this.strikeFixingDates = (List<Long>) newValue;
					break;
				case -175079426:  // avgTypeStrike
					this.avgTypeStrike = (AverageType) newValue;
					break;
				case 267665871:  // priceFixingDates
					this.priceFixingDates = (List<Long>) newValue;
					break;
				case 1792628605:  // avgTypePrice
					this.avgTypePrice = (AverageType) newValue;
					break;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
			return this;
		}

		@Override
		public Builder set(MetaProperty<?> property, Object value) {
			super.set(property, value);
			return this;
		}

		@Override
		public AsianOption build() {
			return new AsianOption(this);
		}

		//-----------------------------------------------------------------------
		/**
		 * Sets the callPut.
		 * @param callPut  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder callPut(CallPut callPut) {
			JodaBeanUtils.notNull(callPut, "callPut");
			this.callPut = callPut;
			return this;
		}

		/**
		 * Sets the strikeFixingDates.
		 * @param strikeFixingDates  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder strikeFixingDates(List<Long> strikeFixingDates) {
			JodaBeanUtils.notNull(strikeFixingDates, "strikeFixingDates");
			this.strikeFixingDates = strikeFixingDates;
			return this;
		}

		/**
		 * Sets the {@code strikeFixingDates} property in the builder
		 * from an array of objects.
		 * @param strikeFixingDates  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder strikeFixingDates(Long... strikeFixingDates) {
			return strikeFixingDates(ImmutableList.copyOf(strikeFixingDates));
		}

		/**
		 * Sets the avgTypeStrike.
		 * @param avgTypeStrike  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder avgTypeStrike(AverageType avgTypeStrike) {
			JodaBeanUtils.notNull(avgTypeStrike, "avgTypeStrike");
			this.avgTypeStrike = avgTypeStrike;
			return this;
		}

		/**
		 * Sets the priceFixingDates.
		 * @param priceFixingDates  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder priceFixingDates(List<Long> priceFixingDates) {
			JodaBeanUtils.notNull(priceFixingDates, "priceFixingDates");
			this.priceFixingDates = priceFixingDates;
			return this;
		}

		/**
		 * Sets the {@code priceFixingDates} property in the builder
		 * from an array of objects.
		 * @param priceFixingDates  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder priceFixingDates(Long... priceFixingDates) {
			return priceFixingDates(ImmutableList.copyOf(priceFixingDates));
		}

		/**
		 * Sets the avgTypePrice.
		 * @param avgTypePrice  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder avgTypePrice(AverageType avgTypePrice) {
			JodaBeanUtils.notNull(avgTypePrice, "avgTypePrice");
			this.avgTypePrice = avgTypePrice;
			return this;
		}

		//-----------------------------------------------------------------------
		@Override
		public String toString() {
			StringBuilder buf = new StringBuilder(192);
			buf.append("AsianOption.Builder{");
			int len = buf.length();
			toString(buf);
			if (buf.length() > len) {
				buf.setLength(buf.length() - 2);
			}
			buf.append('}');
			return buf.toString();
		}

		protected void toString(StringBuilder buf) {
			buf.append("callPut").append('=').append(JodaBeanUtils.toString(callPut)).append(',').append(' ');
			buf.append("strikeFixingDates").append('=').append(JodaBeanUtils.toString(strikeFixingDates)).append(',').append(' ');
			buf.append("avgTypeStrike").append('=').append(JodaBeanUtils.toString(avgTypeStrike)).append(',').append(' ');
			buf.append("priceFixingDates").append('=').append(JodaBeanUtils.toString(priceFixingDates)).append(',').append(' ');
			buf.append("avgTypePrice").append('=').append(JodaBeanUtils.toString(avgTypePrice)).append(',').append(' ');
		}

	}

	//-------------------------- AUTOGENERATED END --------------------------
}
